Overview | Modules | Class Hierarchy | Classes | Members

# tlp::LayoutProperty Class Reference
[Properties]

`#include <LayoutProperty.h>`

Inherits tlp::AbstractProperty< PointType, LineType, LayoutAlgorithm >, and tlp::PropertyObserver.

Inheritance diagram for tlp::LayoutProperty:

[legend]
Collaboration diagram for tlp::LayoutProperty:

[legend]
List of all members.

## Public Member Functions

- LayoutProperty (Graph *, std::string n="")
- PropertyInterface * clonePrototype (Graph *, const std::string &)
- void copy (const node, const node, PropertyInterface *)
- void copy (const edge, const edge, PropertyInterface *)
- Coord getMax (Graph *graph=0)
- Coord getMin (Graph *graph=0)
- void translate (const tlp::Vector< float, 3 > &v, Graph *graph=0)
- void translate (const tlp::Vector< float, 3 > &v, Iterator< node > *, Iterator< edge > *)
- void scale (const tlp::Vector< float, 3 > &v, Graph *graph=0)
- void scale (const tlp::Vector< float, 3 > &v, Iterator< node > *, Iterator< edge > *)
- void rotateZ (const double &alpha, Graph *graph=0)
- void rotateX (const double &alpha, Iterator< node > *, Iterator< edge > *)
- void rotateY (const double &alpha, Iterator< node > *, Iterator< edge > *)
- void rotateZ (const double &alpha, Iterator< node > *, Iterator< edge > *)
- void center (Graph *graph=0)
- void normalize (Graph *graph=0)
- void perfectAspectRatio ()
- void resetBoundingBox ()
- double edgeLength (edge e)
- double averageAngularResolution (Graph *graph=0)
- double averageAngularResolution (const node n, Graph *graph=0)
- std::vector< double > angularResolutions (const node n, Graph *graph=0)
- unsigned int crossingNumber ()
- virtual void beforeSetNodeValue (PropertyInterface *prop, const node n)
- virtual void beforeSetEdgeValue (PropertyInterface *prop, const edge e)
- virtual void beforeSetAllNodeValue (PropertyInterface *prop)
- virtual void beforeSetAllEdgeValue (PropertyInterface *prop)

## Protected Member Functions

- void clone_handler (AbstractProperty< PointType, LineType > &)

## Friends

- class LayoutAlgorithm

## Constructor & Destructor Documentation

tlp::LayoutProperty::LayoutProperty | ( | Graph * | ,
|  | std::string | n = `""`
| ) |

## Member Function Documentation

std::vector<double> tlp::LayoutProperty::angularResolutions | ( | const node | n,
|  | Graph * | graph = `0`
| ) |

| Returns a vector of all angular resolution of a node it is defined for 2D drawing, the third coordinates is omitted

double tlp::LayoutProperty::averageAngularResolution | ( | const node | n,
|  | Graph * | graph = `0`
| ) |

| Returns the average angular resolution of a node it is defined for 2D drawing, the third coordinates is omitted

double tlp::LayoutProperty::averageAngularResolution | ( | Graph * | graph = `0` | ) |

| Returns the average angular resolution of the layout it is defined for 2D drawing, the third coordinates is omitted

virtual void tlp::LayoutProperty::beforeSetAllEdgeValue | ( | PropertyInterface * | prop | ) | `[virtual]`

| Reimplemented from tlp::PropertyObserver.

virtual void tlp::LayoutProperty::beforeSetAllNodeValue | ( | PropertyInterface * | prop | ) | `[virtual]`

| Reimplemented from tlp::PropertyObserver.

virtual void tlp::LayoutProperty::beforeSetEdgeValue | ( | PropertyInterface * | prop,
|  | const edge | e
| ) | `[virtual]`

| Reimplemented from tlp::PropertyObserver.

virtual void tlp::LayoutProperty::beforeSetNodeValue | ( | PropertyInterface * | prop,
|  | const node | n
| ) | `[virtual]`

| Reimplemented from tlp::PropertyObserver.

void tlp::LayoutProperty::center | ( | Graph * | graph = `0` | ) |

void tlp::LayoutProperty::clone_handler | ( | AbstractProperty< PointType, LineType > & |  | ) | `[protected]`

PropertyInterface* tlp::LayoutProperty::clonePrototype | ( | Graph * | ,
|  | const std::string & |
| ) | `[virtual]`

| Implements tlp::PropertyInterface.

void tlp::LayoutProperty::copy | ( | const | edge,
|  | const | edge,
|  | PropertyInterface * |
| ) | `[virtual]`

| Implements tlp::PropertyInterface.

void tlp::LayoutProperty::copy | ( | const | node,
|  | const | node,
|  | PropertyInterface * |
| ) | `[virtual]`

| Implements tlp::PropertyInterface.

unsigned int tlp::LayoutProperty::crossingNumber | ( |  | ) |

| Returns the number of crossings in the layout

double tlp::LayoutProperty::edgeLength | ( | edge | e | ) |

| Returns the length of an edge, the bends are taken into account. Thus, it measure the length of a polyline. Warning this function only measure the length of the polyline between bends, when using curves like bezier etc... the result will not be the length of the curve.

Coord tlp::LayoutProperty::getMax | ( | Graph * | graph = `0` | ) |

Coord tlp::LayoutProperty::getMin | ( | Graph * | graph = `0` | ) |

void tlp::LayoutProperty::normalize | ( | Graph * | graph = `0` | ) |

void tlp::LayoutProperty::perfectAspectRatio | ( |  | ) |

void tlp::LayoutProperty::resetBoundingBox | ( |  | ) |

void tlp::LayoutProperty::rotateX | ( | const double & | alpha,
|  | Iterator< node > * | ,
|  | Iterator< edge > * |
| ) |

| Rotates the passed nodes and edges in the given layout proxy by alpha degrees

void tlp::LayoutProperty::rotateY | ( | const double & | alpha,
|  | Iterator< node > * | ,
|  | Iterator< edge > * |
| ) |

void tlp::LayoutProperty::rotateZ | ( | const double & | alpha,
|  | Iterator< node > * | ,
|  | Iterator< edge > * |
| ) |

void tlp::LayoutProperty::rotateZ | ( | const double & | alpha,
|  | Graph * | graph = `0`
| ) |

| Rotates the layout proxy of the passed graph by alpha degrees

void tlp::LayoutProperty::scale | ( | const tlp::Vector< float, 3 > & | v,
|  | Iterator< node > * | ,
|  | Iterator< edge > * |
| ) |

void tlp::LayoutProperty::scale | ( | const tlp::Vector< float, 3 > & | v,
|  | Graph * | graph = `0`
| ) |

void tlp::LayoutProperty::translate | ( | const tlp::Vector< float, 3 > & | v,
|  | Iterator< node > * | ,
|  | Iterator< edge > * |
| ) |

void tlp::LayoutProperty::translate | ( | const tlp::Vector< float, 3 > & | v,
|  | Graph * | graph = `0`
| ) |

## Friends And Related Function Documentation

friend class LayoutAlgorithm`[friend]`

Tulip Software by LaBRI Visualization Team 2001 - 2010